local shader = love.graphics.newShader("shader")

function setPattern(pattern)
  -- bitshifting does not work in shaders, so do it here in Lua
  local pixels = {}
  for i = 1, 8 do
    for j = 7, 0, -1 do
      local b = bit.lshift(1, j)
      if bit.band(pattern[i], b) == b then
        table.insert(pixels, 1)
      else
        table.insert(pixels, 0)
      end
    end
  end
  
  shader:send("pattern", unpack(pixels))
end

function love.draw()
  love.graphics.setShader(shader)
  setPattern({0x55, 0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55, 0xAA})
  love.graphics.rectangle("fill", 0, 0, 100, 100)
end